package cornell.cs211;

import java.util.Iterator;

public class HeapTest {
    private void startTest(String msg) {
        System.out.println("=== " + msg);
    }
    
    public void unsortedListHeapTest() {
        startTest("UnsortedListHeap Tests");
        UnsortedHeap<Long> h = UnsortedHeap.unsortedListHeap((Long)null);
        h.push(12L);
        h.push(10L);
        h.push(18L);
        System.out.println("TOP: " + h.top());
        System.out.println("POP: " + h.pop());
        System.out.println("TOP: " + h.top());
        h.push(90L);
        h.push(11L);
        h.push(23L);
        System.out.println("SIZE: " + h.size());
        for(Iterator<Long> it = h.iterator();it.hasNext();)
            System.out.print(" "+it.next());
        System.out.println();
    }
    
    public void sortedArrayHeapTests() {
        startTest("sortedArrayHeapTests Tests");
        SortedHeap<Integer> h = SortedHeap.sortedArrayHeap((Integer)null);
        h.push(12);
        h.push(10);
        h.push(18);
        System.out.println("TOP: " + h.top());
        System.out.println("POP: " + h.pop());
        System.out.println("TOP: " + h.top());
        h.push(90);
        h.push(11);
        h.push(23);
        System.out.println("SIZE: " + h.size());
        for(Iterator<Integer> it = h.iterator();it.hasNext();)
            System.out.print(" "+it.next());
        System.out.println();
    }
    
    public void sortedListHeapTests() {
        startTest("sortedListHeapTests Tests");
        SortedHeap<Integer> h = SortedHeap.sortedListHeap((Integer)null);
        h.push(12);
        h.push(10);
        h.push(18);
        System.out.println("TOP: " + h.top());
        System.out.println("POP: " + h.pop());
        System.out.println("TOP: " + h.top());
        h.push(90);
        h.push(11);
        h.push(23);
        System.out.println("SIZE: " + h.size());
        for(Iterator<Integer> it = h.iterator();it.hasNext();)
            System.out.print(" "+it.next());
        System.out.println();
    }
    
    public void stdHeapTests() {
        startTest("StdHeap Tests");
        StdHeap<Integer> h = new StdHeap<Integer>();
        h.push(12);
        h.push(10);
        h.push(18);
        System.out.println("TOP: " + h.top());
        System.out.println("POP: " + h.pop());
        System.out.println("TOP: " + h.top());
        h.push(90);
        h.push(11);
        h.push(23);
        System.out.println("SIZE: " + h.size());
        for(Iterator<Integer> it = h.iterator();it.hasNext();)
            System.out.print(" "+it.next());
        System.out.println();
    }
    
    public static void main(String args[]) {
        HeapTest tester = new HeapTest();
        tester.stdHeapTests();
        tester.unsortedListHeapTest();
        tester.sortedArrayHeapTests();
        tester.sortedListHeapTests();
    }
}
